// Copyright 2009 Christopher Smith
// 
// This file is part of smithers.calculator.
// 
// smithers.calculator is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by the
// Free Software Foundation, either version 3 of the License, or (at your
// option) any later version.
// 
// smithers.calculator is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
// more details.
// 
// You should have received a copy of the GNU General Public License along with
// smithers.calculator. If not, see <http://www.gnu.org/licenses/>.

package smithers.calculator;

class CalcComplexDouble extends CalcObject {
    
    double re, im;
    
    CalcComplexDouble(double real, double imaginary) {
        this.re = real;
        this.im = imaginary;
    }
    
    static CalcComplexDouble fromAbsArg(double abs, double arg) {
        return new CalcComplexDouble(abs * Math.cos(arg), abs * Math.sin(arg));
    }
    
    double abs() {
        return Math.hypot(im, re);
    }
    
    double arg() {
        return Math.atan2(im, re);
    }
    
    public String toString() {
        if (im == 0.0) return Double.toString(re);
        if (re == 0.0) return im + "i";
        return re + "+" + im + "i";
    }
    
}
